/* ipc_recv.c */
# define IPC_RECV_H
# include "ipc_recv.h"

ssize_t recvn(int fd, char * buf, size_t len) {
   char *    ptr = buf;
   size_t    nc;
   ssize_t   n;
   int       flags = 0;
   int       j;

   /*
   flags |= MSG_WAITALL;
   */

   for (nc = len; nc > 0; ptr += n, nc -= n) {
       if ((n = recv(fd, ptr, nc, flags)) < 0)
           if (errno == EINTR) {
	      n = 0;
	      continue;
           } else
               return (nc < len) ? len - nc : -1;
        else if (n == 0) {
           errno = ENOTCONN;
           return (nc < len) ? len - nc : 0;
        }
	for (j = 0; j < n; j++)
	   if (ptr[j] == '\n')
	      return len - nc + n;
   }

   return len;
}
